#include"motor.h"
#include <EnableInterrupt.h>

/*
 * en EnablePin
 * m1 Motorpin1
 * m2 Motorpin2
 * i1 Inputpin1 Lichtschranke
 * mmps Auflösung in mm/Step
 */
Motor MR(6 ,4 ,5 ,3, 5.8119415);
Motor ML(9 ,11 ,10 ,8 , 5.8119415);

String s;
float al,vj=0,v=0,dv,vr,vl;
int knopf;

void setup() 
{
  Serial.begin(9600);
  enableInterrupt(8,iRoutineL,CHANGE);  // Wenn sich i8 oder i3 ändern, sollen die 
  enableInterrupt(3,iRoutineR,CHANGE);  
}

void einMeter()
{
  double stop=(MR.getS()+ML.getS())/2.0+2000.0;
  while((MR.getS()+ML.getS())/2.0<stop)
    {
       MR.setVSoll(400);
       ML.setVSoll(400);
       MR.fPID();
       ML.fPID();
       delay(50);
    }
       MR.setVSoll(0);
       ML.setVSoll(0);
}

void eineSekunde()
{
  long tstop=millis()+2000;
  while(millis()<tstop)
    {
       MR.power(100);
       ML.power(100);
    }
       MR.setVSoll(0);
       ML.setVSoll(0);
       MR.aus();
       ML.aus();
}

void loop() 
{ 
  if(Serial.available())
  {
    s=Serial.readStringUntil('#');
    if (s.length()==7)
    {
      al=s.substring(0,3).toFloat();
      vj=s.substring(3,6).toFloat();
      knopf=s.substring(6,8).toInt();
    }
    s="";
  }    
  
  if (knopf==3) einMeter();
  if (knopf==1) eineSekunde();
  knopf=10;

  dv=cos(al/180*3.14159)*vj*3;
  v= sin(al/180*3.14159)*vj*10;  
  vr=v-dv;
  vl=v+dv;

  MR.setVSoll(vr);
  ML.setVSoll(vl);
  if (vj==0)
  {
    MR.aus();
    ML.aus();
  }

  ML.fPID();
  MR.fPID();
  delay(10);
}

void iRoutineL() 
{
  ML.richtung();
}

void iRoutineR() 
{
  MR.richtung();
}
