#ifndef Motor_h
#define Motor_h

# include "Arduino.h"


class Motor
{
  private:
  int en,m1,m2,i1;
  int mpower=0;
  volatile long steps=0;         // Einzelschritte (steps)
  volatile long stepsalt=0;
  volatile long talt,tneu;       // Zeitpunkt der Messungen
  volatile float f;              // Schrittfrequenz
  float mmps;                    // Auflösung in mm / Schritt
  double fsoll=0.0;              // Soll Frequenz
  //float fp=1.0,fi=10.0,ferri=0.0; // PID-Berechnung
  float fp=0.5,fi=4.0,ferri=0.0; // PID-Berechnung
  long ftalt;                    // Zeitpunkt des letzten Regelprozesses
  
  public:
  
  Motor(int e,int a,int b,int c,float f);
  power(int p);
  void richtung(); /*
                    * Wird immer ausgeführt, wenn eine Änderung bei 
                    * i1 auftritt
                    */
  long getSteps(); // Liefert die bisher gemachten Eintelschritte
  float getF();    // Liefert die Step-Frequenz
  double getS();   // Liefert die zurückgelegte Wegstrecke
  double getV();   // Liefert die Geschwindigkeit
  
  void setFSoll(double a); // Setzt die Soll-Drehfrequenz
  void setVSoll(double a); // Setzt die Soll-Geschwindigkeit
  void fPID();             // Regler für die Drehfrequenz
  void aus();
};
#endif
